# std::atomic::fetch_add

From cppreference.com
< cpp‎ | atomic‎ | atomic

| (1) | (since C++11) (member only of `atomic<Integral>` template specialization)
T fetch_add( T arg, std::memory_order order = std::memory_order_seq_cst ); |  |
T fetch_add( T arg, std::memory_order order = std::memory_order_seq_cst ) volatile; |  |
| (2) | (since C++11) (member only of `atomic<T*>` template specialization)
T* fetch_add( std::ptrdiff_t arg, std::memory_order order = std::memory_order_seq_cst ); |  |
T* fetch_add( std::ptrdiff_t arg, std::memory_order order = std::memory_order_seq_cst ) volatile; |  |

Atomically replaces the current value with the result of arithmetic addition of the value and `arg`. The operation is read-modify-write operation. Memory is affected according to the value of `order`.

For signed `Integral` types, arithmetic is defined to use two’s complement representation. There are no undefined results. For `T*` types, the result may be an undefined address, but the operations otherwise have no undefined behavior.

### Parameters

arg | - | the other argument of arithmetic addition
order | - | memory order constraints to enforce

### Return value

The value immediately preceding the effects of this function in the modification order of `*this`.

### Exceptions

`noexcept` specification:
noexcept

### Example

Run this code

    #include <iostream>
    #include <thread>
    #include <atomic>

    std::atomic<long long> data;
    void do_work()
    {
        data.fetch_add(1, std::memory_order_relaxed);
    }

    int main()
    {
        std::thread th1(do_work);
        std::thread th2(do_work);
        std::thread th3(do_work);
        std::thread th4(do_work);
        std::thread th5(do_work);

        th1.join();
        th2.join();
        th3.join();
        th4.join();
        th5.join();

        std::cout << "Result:" << data << '\n';
    }

Output:

    Result:5

### See also

atomic_fetch_add atomic_fetch_add_explicit (C++11)(C++11) | adds a non-atomic value to an atomic object and obtains the previous value of the atomic (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/atomic/atomic/fetch_add&oldid=91452"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template